regina::HSVectorStandard Class Referenceabstract
Normal Hypersurfaces

A normal hypersurface vector using standard tetrahedron-prism coordinates. More...

`#include <hypersurface/hsvectorstandard.h>`

Inheritance diagram for regina::HSVectorStandard:

## Public Member Functions

| HSVectorStandard (size_t length)
| Creates a new vector all of whose entries are initialised to zero. More...
| HSVectorStandard (const Vector< LargeInteger > &cloneMe)
| Creates a new vector that is a clone of the given vector. More...
virtual LargeInteger | tetrahedra (size_t pentIndex, int vertex, const Triangulation< 4 > *triang) const
| Returns the number of tetrahedron pieces of the given type in this normal hypersurface. More...
virtual LargeInteger | prisms (size_t pentIndex, int prismType, const Triangulation< 4 > *triang) const
| Returns the number of prism pieces of the given type in this normal hypersurface. More...
virtual LargeInteger | edgeWeight (size_t edgeIndex, const Triangulation< 4 > *triang) const
| Returns the number of times this normal hypersurface crosses the given edge. More...
const Ray & | coords () const
| Gives read-only access to the underlying vector of coordinates. More...
virtual NormalHypersurfaceVector * | clone () const =0
| Creates a newly allocated clone of this vector. More...
size_t | size () const
| Returns the number of coordinates in the underlying vector. More...
const NLargeInteger & | operator[] (size_t index) const
| Returns the given coordinate from the underlying vector. More...
virtual void | setElement (size_t index, const LargeInteger &value)
| Sets the given normal coordinate to the given value. More...
virtual void | operator+= (const NormalHypersurfaceVector &other)
| Adds the given vector to this vector. More...
virtual void | scaleDown ()
| Scales this vector down by the greatest common divisor of all its elements. More...
virtual bool | isCompact (const Triangulation< 4 > *triang) const
| Determines if the normal hypersurface represented is compact (has finitely many pieces). More...
virtual bool | isVertexLinking (const Triangulation< 4 > *triang) const
| Determines if the normal hypersurface represented is vertex linking. More...
virtual const Vertex< 4 > * | isVertexLink (const Triangulation< 4 > *triang) const
| Determines if a rational multiple of the normal hypersurface represented is the link of a single vertex. More...
virtual const Edge< 4 > * | isThinEdgeLink (const Triangulation< 4 > *triang) const
| Determines if a rational multiple of the normal hypersurface represented is the thin link of a single edge. More...

## Static Public Member Functions

static NormalHypersurfaceVector * | makeZeroVector (const Triangulation< 4 > *triangulation)
static MatrixInt * | makeMatchingEquations (const Triangulation< 4 > *triangulation)
static EnumConstraints * | makeEmbeddedConstraints (const Triangulation< 4 > *triangulation)

## Protected Attributes

Ray | coords_
| The raw vector of normal coordinates. More...

## Detailed Description

A normal hypersurface vector using standard tetrahedron-prism coordinates.

If there are p pentachora in the underlying triangulation, there must be precisely 15p coordinates. The first 15 coordinates will be for the first pentachoron, the next 15 for the second pentachoron and so on. For each pentachoron, the first five represent the number of tetrahedron pieces about vertex 0,...,4, and the next ten represent the number of prism pieces of type 0,...,9 (see NormalHypersurface::prisms() for details).

Python:\n Not present.

The documentation for this class was generated from the following file:

- hypersurface/hsvectorstandard.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).